#----------------------------------------------------------------------------
#
# Makefile for ECS-OS2 which.exe using OpenWatcom 1.6 and above
#
#----------------------------------------------------------------------------

#DEBUG = 1

CC = wcc386
LD = wlink
LB = wlib
RC = wrc

# Machine type -5r Pent -6r Pent Pro
MACHINE= -6r

#Optimization None -od  - Fastest possible -otexan
!ifndef DEBUG
LDDEBUG   = op el
CDEBUG    = -d0
OPT       = -otexan
!else
LDDEBUG   = d all op map op symf
CDEBUG    = -d3 -v
OPT       = -od
!endif

INCLUDE  = .\watcom\include;$(%watcom)\h;$(%watcom)\h\os2
CFLAGS   = -i=$(INCLUDE) $(CDEBUG) -za99 -wx -e25 -zq $(OPT) $(MACHINE) -bm -bt=OS2 -mf
LDFLAGS  = $(LDDEBUG) op maxe=25
LIBFLAGS = -b -c -n -p=512

OBJECTS = which.obj

MISCLIB = filemisc.obj fnexplod.obj fnmatch.obj getname.obj getpagesize.obj &
          langinfo.obj response.obj wildcard.obj

.c:.\;.\watcom\src

.c.obj:
  $(CC) $(CFLAGS) $<

all: which.exe

which.exe: misc.lib $(OBJECTS)
  $(LD) NAME which SYS os2v2 $(LDFLAGS) LIB misc.lib FILE {$(OBJECTS)}

misc.lib: $(MISCLIB)
  $(LB) $(LIBFLAGS) misc.lib $(MISCLIB)

pack: .SYMBOLIC
  lxlite which.exe

clean : .SYMBOLIC
  -@rm *.exe
  @%make cleanrel

cleanrel : .PROCEDURE
  -@rm *.lib
  -@rm *.obj
  -@rm *.sym
  -@rm *.err
  -@rm *.lst
  -@rm *.map
  -@rm *.err


