

#ifndef _MISCLIB_H_
#define _MISCLIB_H_


/* missing from fcntl.h from newlib 1.15.0 */

/* XXX close on exec request; must match UF_EXCLOSE in user.h */
#define FD_CLOEXEC      1       /* posix */

/* fcntl(2) requests */
#define F_DUPFD         0       /* Duplicate fildes */
#define F_GETFD         1       /* Get fildes flags (close on exec) */
#define F_SETFD         2       /* Set fildes flags (close on exec) */
#define F_GETFL         3       /* Get file flags */
#define F_SETFL         4       /* Set file flags */
#define F_GETLK         7       /* Get record-locking information */
#define F_SETLK         8       /* Set or Clear a record-lock (Non-Blocking) */
#define F_SETLKW        9       /* Set or Clear a record-lock (Blocking) */

/* fcntl(2) flags (l_type field of flock structure) */
#define F_RDLCK         1       /* read lock */
#define F_WRLCK         2       /* write lock */
#define F_UNLCK         3       /* remove lock(s) */

#ifndef _IO_H_INCLUDED
#include <io.h>
#endif

/*
 * Advisory file segment locking data type -
 * information passed to system by user
 */
struct flock {
        off_t   l_start;        /* starting offset */
        off_t   l_len;          /* len = 0 means until end of file */
        pid_t   l_pid;          /* lock owner */
        short   l_type;         /* lock type: read/write, etc. */
        short   l_whence;       /* type of l_start */
};

/* argv[i][-1] contains some flag bits: */

#define _ARG_DQUOTE   0x01          /* Argument quoted (")                  */
#define _ARG_RESPONSE 0x02          /* Argument read from response file     */
#define _ARG_WILDCARD 0x04          /* Argument expanded from wildcard      */
#define _ARG_ENV      0x08          /* Argument from environment            */
#define _ARG_NONZERO  0x80          /* Always set, to avoid end of string   */


int  _filesys (const char *, char *, size_t);
char **_fnexplode(const char *);
void _fnexplodefree(char **);
char _fngetdrive (const char *);
void _fnlwr (char *);
void _fnlwr2 (char *, const char *);
int  getpagesize(void);
char *_getname (const char *path);
void _rfnlwr (void);
void _sfnlwr (const char *);
void _wildcard (int *, char ***);
void _response (int *, char ***);

int fcntl(int, int, ...);  // fcntl(int fildes, int cmd, ...);


#endif
