/*
 * fnexplod.c (emx+gcc) -- Copyright (c) 1992-1996 by Eberhard Mattes
 *
 * Modified Feb 2007 for Open Watcom use - MKG
 *
 */

#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <direct.h>
#include <io.h>
#include <misclib.h>


char **_fnexplode (const char *mask)
{
    int  a;
    int  n;
    int  i;

    long handle;

    char **list;
    char **tmp;
    char *p;
    char *q;
    char name[NAME_MAX];

    struct _finddata_t find;
    struct stat st;

    /* Avoid expanding a directory to all the files and directories it
       contains. */
    if (stat (mask, &st) == 0 && S_ISDIR (st.st_mode)) return NULL;

    strncpy (name, mask, sizeof (name));

    p = _getname (name);

    list = NULL; n = 0; a = 0;

    handle = _findfirst (mask, &find);

//    if (_findfirst (mask, 0x10, &find) != 0) return NULL;
// Ok - think 0x10 is to filter directories - I'll do it and check
    if (handle == -1) return NULL;

    do {
        if (find.name[0] != '.' ||
            (find.name[1] != '\0' && (find.name[1] != '.' || find.name[2] != '\0')) ||
            !(find.attrib | 0x10))
        {
            if (n + 1 >= a) {
                a += 32;
                tmp = realloc (list, a * sizeof (char **));
                if (tmp == NULL) {
                    errno = ENOMEM;
                    goto failure;
                }
                list = tmp;
            }
            strcpy (p, find.name);

            _fnlwr2 (name, name);

            q = strdup (name);

            if (q == NULL) {
                errno = ENOMEM;
                goto failure;
            }
            list[n++] = q;
        }
    } while (_findnext(handle, &find) == 0);

    if (list != NULL) list[n] = NULL;

    _findclose(handle);

    return list;

failure:
    if (list != NULL) {
        for (i = 0; i < n; ++i) free (list[i]);
        free (list);
    }

    _findclose(handle);

    return NULL;
}


void _fnexplodefree(char **list)
{
    int  i;

    for (i = 0; list[i] != NULL; ++i) free (list[i]);

    free (list);
}
